Index: src/mlx/gui/delaycodes.py
===================================================================
--- src/mlx/gui/delaycodes.py	(revision 768)
+++ src/mlx/gui/delaycodes.py	(revision 555)
@@ -375,6 +375,5 @@
         for column in columns:
             self._treeView.remove_column(column)
-        if self._table is not None:
-            self._eventBox.remove(self._table)
+        self._eventBox.remove(self._table)
         self._table = None
         self.show_all()
Index: src/mlx/gui/flight.py
===================================================================
--- src/mlx/gui/flight.py	(revision 777)
+++ src/mlx/gui/flight.py	(revision 739)
@@ -11,5 +11,5 @@
 import mlx.util as util
 from mlx.pirep import PIREP
-from mlx.i18n import xstr, getLanguage
+from mlx.i18n import xstr
 from mlx.sound import startSound
 import mlx.web as web
@@ -20,6 +20,4 @@
 import tempfile
 import threading
-import re
-import webbrowser
 
 #-----------------------------------------------------------------------------
@@ -63,5 +61,5 @@
 class Page(gtk.Alignment):
     """A page in the flight wizard."""
-    def __init__(self, wizard, id, title, help, completedHelp = None):
+    def __init__(self, wizard, title, help, completedHelp = None):
         """Construct the page."""
         super(Page, self).__init__(xalign = 0.0, yalign = 0.0,
@@ -141,6 +139,4 @@
 
         self._wizard = wizard
-        self._id = id
-        self._nextPageID = None
 
         self._cancelFlightButton = None
@@ -148,19 +144,4 @@
         self._completed = False
         self._fromPage = None
-
-    @property
-    def id(self):
-        """Get the identifier of the page."""
-        return self._id
-
-    @property
-    def nextPageID(self):
-        """Get the identifier of the next page, if set."""
-        return self._nextPageID
-
-    @nextPageID.setter
-    def nextPageID(self, nextPageID):
-        """Set the identifier of the next page."""
-        self._nextPageID = nextPageID
 
     def setMainWidget(self, widget):
@@ -169,6 +150,5 @@
 
     def addButton(self, label, default = False, sensitive = True,
-                  tooltip = None, clicked = None, padding = 4,
-                  clickedArg = None):
+                  tooltip = None, clicked = None, padding = 4):
         """Add a button with the given label.
 
@@ -184,8 +164,5 @@
             button.set_tooltip_text(tooltip)
         if clicked is not None:
-            if clickedArg is None:
-                button.connect("clicked", clicked)
-            else:
-                button.connect("clicked", clicked, clickedArg)
+            button.connect("clicked", clicked)
         return button
 
@@ -300,11 +277,11 @@
     def __init__(self, wizard):
         """Construct the login page."""
-        super(LoginPage, self).__init__(wizard, "login",
-                                        xstr("login"), xstr("loginHelp"))
+        super(LoginPage, self).__init__(wizard, xstr("login"),
+                                        xstr("loginHelp"))
 
         alignment = gtk.Alignment(xalign = 0.5, yalign = 0.5,
                                   xscale = 0.0, yscale = 0.0)
 
-        table = gtk.Table(3, 2)
+        table = gtk.Table(4, 2)
         table.set_row_spacings(4)
         table.set_col_spacings(32)
@@ -344,7 +321,9 @@
         table.attach(self._rememberButton, 1, 2, 2, 3, ypadding = 8)
 
-        self.addButton(xstr("button_login_register"),
-                       clicked = self._registerClicked,
-                       tooltip = xstr("button_login_register_tooltip"))
+        self._entranceExam = gtk.CheckButton(xstr("login_entranceExam"))
+        self._entranceExam.set_use_underline(True)
+        self._entranceExam.set_tooltip_text(xstr("login_entranceExam_tooltip"))
+        self._entranceExam.connect("toggled", self._setControls)
+        table.attach(self._entranceExam, 1, 2, 3, 4, ypadding = 12)
 
         self.addButton(xstr("button_offline"),
@@ -356,4 +335,10 @@
         self._loginButton.set_tooltip_text(xstr("login_button_tooltip"))
 
+
+    @property
+    def entranceExam(self):
+        """Get whether an entrance exam is being performed."""
+        return self._entranceExam.get_active() and \
+               self._pilotID.get_text()!=""
 
     @property
@@ -394,10 +379,10 @@
         pilotID = self._pilotID.get_text()
         password = self._password.get_text()
-        self._rememberButton.set_sensitive(password!="")
-        self._loginButton.set_sensitive(pilotID!="" and password!="")
-
-    def _registerClicked(self, button):
-        """Called when the Register button was clicked."""
-        self._wizard.jumpPage("register")
+        entranceExam = self._entranceExam.get_active()
+        self._password.set_sensitive(not entranceExam)
+        self._rememberButton.set_sensitive(password!="" and not entranceExam)
+        self._entranceExam.set_sensitive(pilotID!="")
+        self._loginButton.set_sensitive(pilotID!="" and
+                                        (password!="" or entranceExam))
 
     def _offlineClicked(self, button):
@@ -411,5 +396,6 @@
         self._wizard.login(self._handleLoginResult,
                            self._pilotID.get_text(),
-                           self._password.get_text())
+                           self._password.get_text(),
+                           self.entranceExam)
 
     def _handleLoginResult(self, returned, result):
@@ -427,8 +413,5 @@
 
             config.save()
-            if result.rank=="STU":
-                self._wizard.jumpPage("student")
-            else:
-                self._wizard.nextPage()
+            self._wizard.nextPage()
 
 #-----------------------------------------------------------------------------
@@ -440,6 +423,5 @@
         help = xstr("flightsel_help")
         completedHelp = xstr("flightsel_chelp")
-        super(FlightSelectionPage, self).__init__(wizard, "flightsel",
-                                                  xstr("flightsel_title"),
+        super(FlightSelectionPage, self).__init__(wizard, xstr("flightsel_title"),
                                                   help, completedHelp = completedHelp)
 
@@ -621,5 +603,5 @@
         """Called when the forward button was clicked."""
         if self._completed:
-            self._wizard.jumpPage(self._nextID, finalize = False)
+            self._wizard.jumpPage(self._nextDistance, finalize = False)
         else:
             self._flightSelected()
@@ -676,30 +658,30 @@
                                          const.PLANE_AWAY)
         else:
-            self._nextID = "connect"
-            self._wizard.jumpPage("connect")
+            self._nextDistance = 2
+            self._wizard.jumpPage(2)
 
     def _fleetRetrieved(self, fleet):
         """Called when the fleet has been retrieved."""
         if fleet is None:
-            self._nextID = "connect"
-            self._wizard.jumpPage("connect")
+            self._nextDistance = 2
+            self._wizard.jumpPage(2)
         else:
             plane = fleet[self._wizard._bookedFlight.tailNumber]
             if plane is None:
-                self._nextID = "connect"
-                self._wizard.jumpPage("connect")
+                self._nextDistance = 2
+                self._wizard.jumpPage(2)
             elif plane.gateNumber is not None and \
                  not fleet.isGateConflicting(plane):
                 self._wizard._departureGate = plane.gateNumber
-                self._nextID = "connect"
-                self._wizard.jumpPage("connect")
+                self._nextDistance = 2
+                self._wizard.jumpPage(2)
             else:
-                self._nextID = "gatesel"
-                self._wizard.jumpPage("gatesel")
+                self._nextDistance = 1
+                self._wizard.nextPage()
 
     def _planeUpdated(self, success):
         """Callback for the plane updating."""
-        self._nextID = "connect"
-        self._wizard.jumpPage("connect")
+        self._nextDistance = 2
+        self._wizard.jumpPage(2)
 
     def _getSaveDialog(self):
@@ -804,6 +786,5 @@
     def __init__(self, wizard):
         """Construct the gate selection page."""
-        super(GateSelectionPage, self).__init__(wizard, "gatesel",
-                                                xstr("gatesel_title"),
+        super(GateSelectionPage, self).__init__(wizard, xstr("gatesel_title"),
                                                 xstr("gatesel_help"))
 
@@ -868,5 +849,5 @@
             self._gateSelected()
         else:
-            self._wizard.jumpPage("connect")
+            self._wizard.nextPage()
 
     def _rowActivated(self, flightList, path, column):
@@ -890,5 +871,5 @@
         """Callback for the plane updating call."""
         if success is None or success:
-            self._wizard.jumpPage("connect")
+            self._wizard.nextPage()
         else:
             dialog = gtk.MessageDialog(parent = self._wizard.gui.mainWindow,
